#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"



static int fsave(char *name, D88 &d, int trk, int sec, int size){
	FILE *f;
	int errcode;
	unsigned char idbuf[256];
	unsigned char buf[128 << 7];
	int maxsec;
	int k;
	int t_size;

	if(0 >= sec){
		return 2;
	}
	if(0 > size){
		return 1;
	}

	errcode = 0;

	f = fopen(name, "wb");

	maxsec = 0;
	do{
		if(maxsec < sec){
			if(0 != maxsec){
				trk += 1;
				sec = 1;
			}
			memset(idbuf, 0, sizeof(idbuf));
			maxsec = d.ReadID(trk, idbuf, sizeof(idbuf));
			if(0 == maxsec){
				errcode = 3;
				break;
			}
			maxsec = (maxsec / 4);
		}

		for(k = 0; maxsec > k; ++k){
			if(sec == idbuf[(k * 4) + 2]){
				break;
			}
		}
		if(maxsec <= k){
			errcode = 4;
			break;
		}

		t_size = (128 << idbuf[(k * 4) + 3]);
		if((0 != size) && (size < t_size)){
			t_size = size;
		}
		
		d.ReadDATA1(trk, idbuf[k * 4], idbuf[(k * 4) + 1], idbuf[(k * 4) + 2], idbuf[(k * 4) + 3], buf, t_size);
		fwrite(buf, 1, t_size, f);
		size -= t_size;

		sec += 1;
	}while(0 < size);

	fclose(f);
	if(0 != errcode){
		delete(name);
	}

	return errcode;
}


// }VA 2DD
static int romancia98(D88 &d, char *name){
	FILE *f;
	unsigned char idx[0x400];
	unsigned char buf[0x400];
	int ofs;
	int trk, id_c, id_h, id_r;
	int size;
	int k;
	char t_name[16];

	d.SelectDisk(0);

	{
		int k;
		int t;
		unsigned char idbuf[256];

		t = d.ReadID(0, idbuf, sizeof(idbuf));
		if(0x40 != t){
			return 1;
		}
		if((0 != idbuf[0]) || (0 != idbuf[1]) || (1 != idbuf[3])){
			return 2;
		}
		t = d.ReadID(1, idbuf, sizeof(idbuf));
		if(0x14 != t){
			return 1;
		}
		if((0 != idbuf[0]) || (1 != idbuf[1]) || (3 != idbuf[3])){
			return 2;
		}

		for(k = 2; 158 > k; ++k){
			if((k >= 78) && (0 == ((k + 2) & 2))){
				continue;
			}
			t = d.ReadID(k, idbuf, sizeof(idbuf));
			if(0x14 != t){
				return 3;
			}
			t = (k + 2);
			if((t >> 2) != idbuf[0]){
				return 4;
			}
			if((t & 1) != idbuf[1]){
				return 5;
			}
			if(3 != idbuf[3]){
				return 6;
			}
		}

		puts("}VA2DDłł");
	}

	memset(idx, 0, sizeof(idx));
	d.ReadDATA(1, 0, 1, 1, 3, idx, 0x400);

	for(ofs = 0; 0xff != idx[ofs]; ofs += 16){
		for(k = 0; 7 > k; ++k){
			int c = idx[ofs + k];
			if(0x20 >= c){
				break;
			}
			t_name[k] = c;
		}
		t_name[k] = '\0';
		if(NULL != name){
			if(0 != strcmp(name, t_name)){
				continue;
			}
		}

		trk = idx[ofs + 12];
		id_r = idx[ofs + 13];

		size = (((idx[ofs + 14] - trk) * 5) + (idx[ofs + 15] - id_r) + 1);

		id_c = (trk >> 1);
		id_h = (trk & 1);
		trk = (((trk & 0xfe) << 1) + (trk & 1));

		f = fopen(t_name, "wb");
		for(; 0 < size; --size){
			d.ReadDATA1(trk, id_c, id_h, id_r, 3, buf, 0x400);
			fwrite(buf, 1, 0x400, f);
			id_r += 1;
			if(5 < id_r){
				id_r = 1;
				id_h += 1;
				trk += 1;
				if(1 < id_h){
					id_h = 0;
					id_c += 1;
					trk += 2;
				}
			}
		}
		fclose(f);
	}

	return 0;
}


// z̐_a 2HD
static int taiyo98(D88 &d, char *name){
	FILE *f;
	int diskno;
	unsigned char idx[0x800];
	unsigned char buf[0x400];
	int ofs;
	int trk, id_c, id_h, id_r;
	int size;
	int k;
	char t_name[16];

	d.SelectDisk(0);

	{
		int k;
		int maxsec;
		unsigned char idbuf[256];

		for(k = 0; 2 > k; ++k){
			maxsec = d.ReadID(k, idbuf, sizeof(idbuf));
			if(0x40 != maxsec){
				return 1;
			}
			if((0 != idbuf[0]) || (k != idbuf[1]) || (1 != idbuf[3])){
				return 2;
			}
		}
		for(k = 2; 154 > k; ++k){
			maxsec = d.ReadID(k, idbuf, sizeof(idbuf));
			if(0x14 != maxsec){
				return 3;
			}
			if((k / 4) != idbuf[0]){
				return 4;
			}
			if(((k / 2) & 1) != idbuf[1]){
				return 5;
			}
			if(3 != idbuf[3]){
				return 6;
			}
		}

		puts("z̐_a2HDłł");
	}


	for(diskno = 0; 2 > diskno; ++diskno){
		memset(idx, 0, sizeof(idx));
		d.ReadDATA((2 + diskno), 0, 1, 1, 3, idx, 0x800);

		for(ofs = 0; 0xff != idx[ofs]; ofs += 16){
			for(k = 0; 7 > k; ++k){
				int c = idx[ofs + k];
				if(0x20 >= c){
					break;
				}
				t_name[k] = c;
			}
			t_name[k] = '\0';
			if(NULL != name){
				if(0 != strcmp(name, t_name)){
					continue;
				}
			}

			trk = idx[ofs + 12];
			id_r = idx[ofs + 13];

			size = (((idx[ofs + 14] - trk) * 5) + (idx[ofs + 15] - id_r) + 1);

			id_c = (trk >> 1);
			id_h = (trk & 1);
			trk = ((trk * 2) + diskno);

			f = fopen((char*)(idx + ofs), "wb");
			for(; 0 < size; --size){
				d.ReadDATA1(trk, id_c, id_h, id_r, 3, buf, 0x400);
				fwrite(buf, 1, 0x400, f);
				id_r += 1;
				if(5 < id_r){
					id_r = 1;
					id_h += 1;
					if(1 < id_h){
						id_h = 0;
						id_c += 1;
					}
					trk += 2;
				}
			}
			fclose(f);
		}

	}
	return 0;
}



// d88cutǂ
static int d88cut(D88 &d, int argc, char *argv[]){
	int diskno, trk, sec;
	int size, ofs;
	int errcode;

	if(6 > argc){
		return -1;
	}

	{
		char *p;
		diskno = strtol(argv[3], &p, 0);
		trk = strtol(argv[4], &p, 0);
		sec = strtol(argv[5], &p, 0);
		size = 0;
		ofs = 0;
		if(7 <= argc){
			size = strtol(argv[6], &p, 0);
		}
		if(8 <= argc){
			ofs = strtol(argv[7], &p, 0);
		}
	}

	if(false == d.SelectDisk(diskno)){
		puts("w肵 diskno ݂܂");
		return -1;
	}

	printf("diskno:%2d track:%2d sector:%2d size:%d ؂o܂\n", diskno, trk, sec, size);

	errcode = fsave(argv[2], d, trk, sec, size);
	if(1 == errcode){
		puts("TCY̎w肪ł");
	}
	if(1 < errcode){
		puts("w肵gbN/ZN^݂܂");
		printf("%d\n", errcode);
	}

	return errcode;
}




int main(int argc, char *argv[]){
	D88 d;
	int errcode;

	errcode = 0;

	if(2 > argc){
		puts(argv[0]);
		exit(0);
	}

	if(false == d.SetFile(argv[1])){
		printf("t@C݂܂ (%s", argv[1]);
		exit(1);
	}

	if(3 >= argc){
		char *t;
		t = NULL;
		if(3 == argc){
			int k;
			t = argv[2];
			for(k = 0; '\0' != t[k]; ++k){
				t[k] = toupper(t[k]);
			}
		}
		errcode = taiyo98(d, t);
		if(0 != errcode){
			errcode = romancia98(d, t);
		}
		if(0 != errcode){
			puts("Ή̌`ł");
			errcode = 1;
		}
	}
	else if(6 <= argc){
		errcode = d88cut(d, argc, argv);
	}
	else{
		puts("̐Ă܂");
		errcode = 1;
	}

	d.SetFile(NULL);

	exit(errcode);
}
